
#    0000000   00000000   0000000   00     00
#   000        000       000   000  000   000
#   000  0000  0000000   000   000  000000000
#   000   000  000       000   000  000 0 000
#    0000000   00000000   0000000   000   000

log    = require '/Users/kodi/s/ko/js/tools/log'
Vector = require './lib/vector'

class Geom

    @wire: ->
        quads = 16
        triangles = quads*2+8
        positions = new Float32Array triangles*9
        normals   = new Float32Array triangles*9
        pi = -1
        pi = @quadStrip positions, normals, pi, @wireQuadStrip1
        pi = @quadStrip positions, normals, pi, @wireQuadStrip2
        pi = @triangleList positions, normals, pi, @wireTriangles
        geom = new THREE.BufferGeometry
        geom.addAttribute 'position', new THREE.BufferAttribute positions, 3 
        geom.addAttribute 'normal',   new THREE.BufferAttribute normals,   3 
        geom.translate 0,0,-0.5+0.008
        geom

    @kolben: ->
        quads = 6+8
        triangles = quads*2
        positions = new Float32Array triangles*9
        normals   = new Float32Array triangles*9
        pi = -1
        pi = @quadList  positions, normals, pi, @kolbenQuads
        pi = @quadStrip positions, normals, pi, @kolbenQuadStrip
        geom = new THREE.BufferGeometry
        geom.addAttribute 'position', new THREE.BufferAttribute positions, 3 
        geom.addAttribute 'normal',   new THREE.BufferAttribute normals,   3   
        geom

    @cylinder: ->
        quads = 16*8
        triangles = quads*2
        positions = new Float32Array triangles*9
        normals   = new Float32Array triangles*9
        pi = -1  
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip1
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip2
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip3
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip4
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip5
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip6
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip7
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip8
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip9
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip10
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip11
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip12
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip13
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip14
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip15
        pi = @quadStrip positions, normals, pi, @cylinderQuadStrip16
        geom = new THREE.BufferGeometry
        geom.addAttribute 'position', new THREE.BufferAttribute positions, 3 
        geom.addAttribute 'normal',   new THREE.BufferAttribute normals,   3   
        geom

    @motor: ->
        quads = 11
        triangles = quads*2+4
        positions = new Float32Array triangles*9
        normals   = new Float32Array triangles*9
        pi = -1  
        pi = @quadList     positions, normals, pi, @motorQuads
        pi = @triangleList positions, normals, pi, @motorTriangles
        geom = new THREE.BufferGeometry
        geom.addAttribute 'position', new THREE.BufferAttribute positions, 3 
        geom.addAttribute 'normal',   new THREE.BufferAttribute normals,   3   
        geom
    
    @generator: ->
        quads = 22+4*8+8*4
        triangles = quads*2
        positions = new Float32Array triangles*9
        normals   = new Float32Array triangles*9
        pi = -1  
        pi = @quadList  positions, normals, pi, @generatorQuads
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip1
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip2
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip3
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip4
        
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip5
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip6
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip7
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip8
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip9
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip10
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip11
        pi = @quadStrip positions, normals, pi, @generatorQuadStrip12
            
        geom = new THREE.BufferGeometry
        geom.addAttribute 'position', new THREE.BufferAttribute positions, 3 
        geom.addAttribute 'normal',   new THREE.BufferAttribute normals,   3   
        geom

    @valve: ->
        quads = 6+5*8
        triangles = quads*2
        positions = new Float32Array triangles*9
        normals   = new Float32Array triangles*9
        pi = -1  
        pi = @quadList  positions, normals, pi, @valveQuads
        pi = @quadStrip positions, normals, pi, @valveQuadStrip1
        pi = @quadStrip positions, normals, pi, @valveQuadStrip2
        pi = @quadStrip positions, normals, pi, @valveQuadStrip3
        pi = @quadStrip positions, normals, pi, @valveQuadStrip4
        pi = @quadStrip positions, normals, pi, @valveQuadStrip5
            
        geom = new THREE.BufferGeometry
        geom.addAttribute 'position', new THREE.BufferAttribute positions, 3 
        geom.addAttribute 'normal',   new THREE.BufferAttribute normals,   3   
        geom

    @gear: ->
        quads = 48+16*3
        triangles = quads*2
        positions = new Float32Array triangles*9
        normals   = new Float32Array triangles*9
        pi = -1  
        pi = @quadList  positions, normals, pi, @gearQuads
        pi = @quadStrip positions, normals, pi, @gearQuadStrip1
        pi = @quadStrip positions, normals, pi, @gearQuadStrip2
        pi = @quadStrip positions, normals, pi, @gearQuadStrip3
            
        geom = new THREE.BufferGeometry
        geom.addAttribute 'position', new THREE.BufferAttribute positions, 3 
        geom.addAttribute 'normal',   new THREE.BufferAttribute normals,   3   
        geom.translate 0,0,0.4
        geom

    #   000000000  00000000   000   0000000   000   000   0000000   000      00000000   0000000
    #      000     000   000  000  000   000  0000  000  000        000      000       000     
    #      000     0000000    000  000000000  000 0 000  000  0000  000      0000000   0000000 
    #      000     000   000  000  000   000  000  0000  000   000  000      000            000
    #      000     000   000  000  000   000  000   000   0000000   0000000  00000000  0000000 

    @triangleList: (positions, normals, pi, triangles) ->
        numTrias = triangles.length/9
        for t in [0...numTrias]
            ti = t * 9
            p0 = new Vector triangles[ti+0], triangles[ti+1], triangles[ti+2]
            p1 = new Vector triangles[ti+3], triangles[ti+4], triangles[ti+5]
            p2 = new Vector triangles[ti+6], triangles[ti+7], triangles[ti+8]
            nv = p1.minus(p0).cross(p2.minus(p0)).normal()
            n = [nv.x, nv.y, nv.z]
            for j in [0,1,2]
                jj = j * 3
                for i in [0...3]
                    positions[pi+=1] = triangles[ti+jj+i]
                    normals[pi] = n[i]
        pi
    
    #    0000000   000   000   0000000   0000000     0000000
    #   000   000  000   000  000   000  000   000  000     
    #   000 00 00  000   000  000000000  000   000  0000000 
    #   000 0000   000   000  000   000  000   000       000
    #    00000 00   0000000   000   000  0000000    0000000 

    @quadList: (positions, normals, pi, quads) ->
        numQuads = quads.length/12
        for q in [0...numQuads]
            qi = q * 12
            p0 = new Vector quads[qi+0], quads[qi+1], quads[qi+2]
            p1 = new Vector quads[qi+3], quads[qi+4], quads[qi+5]
            p2 = new Vector quads[qi+6], quads[qi+7], quads[qi+8]
            nv = p1.minus(p0).cross(p2.minus(p0)).normal()
            n = [nv.x, nv.y, nv.z]
            for j in [0,1,2,0,2,3]
                jj = j * 3
                for i in [0...3]
                    positions[pi+=1] = quads[qi+jj+i]
                    normals[pi] = n[i]
        pi
        
    @quadStrip: (positions, normals, pi, strip) ->
        numQuads = strip.length/6-1
        for q in [0...numQuads]
            qi = q * 6
            p0 = new Vector strip[qi+0], strip[qi+1], strip[qi+2]
            p1 = new Vector strip[qi+3], strip[qi+4], strip[qi+5]
            p2 = new Vector strip[qi+6], strip[qi+7], strip[qi+8]
            nv = p1.minus(p0).cross(p2.minus(p0)).normal()
            n = [nv.x, nv.y, nv.z]
            for j in [0,1,2,2,1,3]
                jj = j*3
                for i in [0...3]
                    positions[pi+=1] = strip[qi+jj+i]
                    normals[pi] = n[i]
        pi    
    
    #   000   000  000  00000000   00000000
    #   000 0 000  000  000   000  000     
    #   000000000  000  0000000    0000000 
    #   000   000  000  000   000  000     
    #   00     00  000  000   000  00000000

    @wireQuadStrip1 = [
        0,  0.18,  0, 0,  0.14,  0.05, 0.14,  0.14,  0, 0.1,  0.1,  0.05, 
        0.18,  0,  0, 0.14,  0,  0.05, 
        0.14, -0.14,  0, 0.1, -0.1,  0.05, 
        0, -0.18,  0, 0, -0.14,  0.05, 
        -0.14, -0.14,  0, -0.1, -0.1,  0.05, 
        -0.18,  0,  0, -0.14,  0,  0.05, 
        -0.14,  0.14,  0, -0.1,  0.1,  0.05, 
        0,  0.18,  0, 0,  0.14,  0.05, 
        ]
    @wireQuadStrip2 = [        
        0,  0.14,  0.05, 0,  0.07,  0.08, 0.1,  0.1,  0.05, 0.05,  0.05,  0.08, 
        0.14,  0,  0.05, 0.07,  0,  0.08, 
        0.1, -0.1,  0.05, 0.05, -0.05,  0.08, 
        0, -0.14,  0.05, 0, -0.07,  0.08, 
        -0.1, -0.1,  0.05, -0.05, -0.05,  0.08, 
        -0.14,  0,  0.05, -0.07,  0,  0.08, 
        -0.1,  0.1,  0.05, -0.05,  0.05,  0.08, 
        0,  0.14,  0.05, 0,  0.07,  0.08, 
        ]
    @wireTriangles = [        
        0,     0.07,  0.08, 0.05,  0.05,  0.08, 0,0,0.02,
        0.05,  0.05,  0.08, 0.07,  0,     0.08, 0,0,0.02,
        0.07,  0,     0.08, 0.05,  -0.05, 0.08, 0,0,0.02,
        0.05,  -0.05, 0.08, 0,     -0.07, 0.08, 0,0,0.02,
        0,     -0.07, 0.08, -0.05, -0.05, 0.08, 0,0,0.02,
        -0.05, -0.05, 0.08, -0.07, 0,     0.08, 0,0,0.02,
        -0.07, 0,     0.08, -0.05, 0.05,  0.08, 0,0,0.02,
        -0.05, 0.05,  0.08, 0,     0.07,  0.08, 0,0,0.02
        ]
        
    #   000   000   0000000   000      0000000    00000000  000   000
    #   000  000   000   000  000      000   000  000       0000  000
    #   0000000    000   000  000      0000000    0000000   000 0 000
    #   000  000   000   000  000      000   000  000       000  0000
    #   000   000   0000000   0000000  0000000    00000000  000   000
    
    @kolbenQuads = [
        -0.1, -0.25, 0.5, -0.1,  0.25, 0.5, -0.25,  0.1, 0.5, -0.25, -0.1, 0.5,
        0.25, -0.1,  0.5, 0.25,  0.1,  0.5, 0.1,  0.25,  0.5, 0.1, -0.25,  0.5,
        -0.1,  0.25, 0.5, -0.1, -0.25, 0.5, 0.1, -0.25,  0.5, 0.1,  0.25,  0.5,
        -0.1,  0.25, 0, -0.1, -0.25, 0, -0.25, -0.1, 0, -0.25,  0.1, 0,
        0.25,  0.1,  0, 0.25, -0.1,  0, 0.1, -0.25,  0, 0.1,  0.25,  0,
        -0.1, -0.25, 0, -0.1,  0.25, 0, 0.1,  0.25,  0, 0.1, -0.25,  0,
        ]
        
    @kolbenQuadStrip = [
        0.1,  0.25, 0, 0.1,  0.25,  0.5, 0.25,  0.1, 0, 0.25,  0.1,  0.5, 
        0.25, -0.1, 0, 0.25, -0.1,  0.5, 
        0.1, -0.25, 0, 0.1, -0.25,  0.5, 
        -0.1, -0.25, 0, -0.1, -0.25,  0.5, 
        -0.25, -0.1, 0, -0.25, -0.1,  0.5, 
        -0.25,  0.1, 0, -0.25,  0.1,  0.5, 
        -0.1,  0.25, 0, -0.1,  0.25,  0.5, 
        0.1,  0.25, 0, 0.1,  0.25,  0.5, 
        ]

    #    0000000  000   000  000      000  000   000  0000000    00000000  00000000 
    #   000        000 000   000      000  0000  000  000   000  000       000   000
    #   000         00000    000      000  000 0 000  000   000  0000000   0000000  
    #   000          000     000      000  000  0000  000   000  000       000   000
    #    0000000     000     0000000  000  000   000  0000000    00000000  000   000

    @cylinderQuadStrip1 = [
        -0.118,  0.284,  0.215, -0.207,  0.499,  0.215, 0.118,  0.284,  0.215, 0.207,  0.499,  0.215, 
        0.285,  0.117,  0.215, 0.500,  0.206,  0.215, 
        0.285, -0.119,  0.215, 0.500, -0.208,  0.215, 
        0.118, -0.285,  0.215, 0.207, -0.501,  0.215, 
        -0.118, -0.285,  0.215, -0.207, -0.501,  0.215, 
        -0.285, -0.119,  0.215, -0.500, -0.208,  0.215, 
        -0.285,  0.117,  0.215, -0.500,  0.206,  0.215, 
        -0.118,  0.284,  0.215, -0.207,  0.499,  0.215, 
        ] 
    @cylinderQuadStrip2 = [
        0.118,  0.284,  0.315, 0.118,  0.284,  0.215, 0.285,  0.117,  0.315, 0.285,  0.117,  0.215, 
        0.285, -0.119,  0.315, 0.285, -0.119,  0.215, 
        0.118, -0.285,  0.315, 0.118, -0.285,  0.215, 
        -0.118, -0.285,  0.315, -0.118, -0.285,  0.215, 
        -0.285, -0.119,  0.315, -0.285, -0.119,  0.215, 
        -0.285,  0.117,  0.315, -0.285,  0.117,  0.215, 
        -0.118,  0.284,  0.315, -0.118,  0.284,  0.215, 
        0.118,  0.284,  0.315, 0.118,  0.284,  0.215, 
        ] 
    @cylinderQuadStrip3 = [
        0.207,  0.499,  0.315, 0.118,  0.284,  0.315, 0.500,  0.206,  0.315, 0.285,  0.117,  0.315, 
        0.500, -0.208,  0.315, 0.285, -0.119,  0.315, 
        0.207, -0.501,  0.315, 0.118, -0.285,  0.315, 
        -0.207, -0.501,  0.315, -0.118, -0.285,  0.315, 
        -0.500, -0.208,  0.315, -0.285, -0.119,  0.315, 
        -0.500,  0.206,  0.315, -0.285,  0.117,  0.315, 
        -0.207,  0.499,  0.315, -0.118,  0.284,  0.315, 
        0.207,  0.499,  0.315, 0.118,  0.284,  0.315, 
        ] 
    @cylinderQuadStrip4 = [
        -0.207,  0.499,  0.215, -0.207,  0.499,  0.315, 0.207,  0.499,  0.215, 0.207,  0.499,  0.315, 
        0.500,  0.206,  0.215, 0.500,  0.206,  0.315, 
        0.500, -0.208,  0.215, 0.500, -0.208,  0.315, 
        0.207, -0.501,  0.215, 0.207, -0.501,  0.315, 
        -0.207, -0.501,  0.215, -0.207, -0.501,  0.315, 
        -0.500, -0.208,  0.215, -0.500, -0.208,  0.315, 
        -0.500,  0.206,  0.215, -0.500,  0.206,  0.315, 
        -0.207,  0.499,  0.215, -0.207,  0.499,  0.315, 
        ] 
    @cylinderQuadStrip5 = [
        -0.118,  0.284,  0.397, -0.207,  0.499,  0.397, 0.118,  0.284,  0.397, 0.207,  0.499,  0.397, 
        0.285,  0.117,  0.397, 0.500,  0.206,  0.397, 
        0.285, -0.119,  0.397, 0.500, -0.208,  0.397, 
        0.118, -0.285,  0.397, 0.207, -0.501,  0.397, 
        -0.118, -0.285,  0.397, -0.207, -0.501,  0.397, 
        -0.285, -0.119,  0.397, -0.500, -0.208,  0.397, 
        -0.285,  0.117,  0.397, -0.500,  0.206,  0.397, 
        -0.118,  0.284,  0.397, -0.207,  0.499,  0.397, 
        ] 
    @cylinderQuadStrip6 = [
        0.118,  0.284,  0.497, 0.118,  0.284,  0.397, 0.285,  0.117,  0.497, 0.285,  0.117,  0.397, 
        0.285, -0.119,  0.497, 0.285, -0.119,  0.397, 
        0.118, -0.285,  0.497, 0.118, -0.285,  0.397, 
        -0.118, -0.285,  0.497, -0.118, -0.285,  0.397, 
        -0.285, -0.119,  0.497, -0.285, -0.119,  0.397, 
        -0.285,  0.117,  0.497, -0.285,  0.117,  0.397, 
        -0.118,  0.284,  0.497, -0.118,  0.284,  0.397, 
        0.118,  0.284,  0.497, 0.118,  0.284,  0.397, 
        ] 
    @cylinderQuadStrip7 = [
        0.207,  0.499,  0.497, 0.118,  0.284,  0.497, 0.500,  0.206,  0.497, 0.285,  0.117,  0.497, 
        0.500, -0.208,  0.497, 0.285, -0.119,  0.497, 
        0.207, -0.501,  0.497, 0.118, -0.285,  0.497, 
        -0.207, -0.501,  0.497, -0.118, -0.285,  0.497, 
        -0.500, -0.208,  0.497, -0.285, -0.119,  0.497, 
        -0.500,  0.206,  0.497, -0.285,  0.117,  0.497, 
        -0.207,  0.499,  0.497, -0.118,  0.284,  0.497, 
        0.207,  0.499,  0.497, 0.118,  0.284,  0.497, 
        ] 
    @cylinderQuadStrip8 = [
        -0.207,  0.499,  0.397, -0.207,  0.499,  0.497, 0.207,  0.499,  0.397, 0.207,  0.499,  0.497, 
        0.500,  0.206,  0.397, 0.500,  0.206,  0.497, 
        0.500, -0.208,  0.397, 0.500, -0.208,  0.497, 
        0.207, -0.501,  0.397, 0.207, -0.501,  0.497, 
        -0.207, -0.501,  0.397, -0.207, -0.501,  0.497, 
        -0.500, -0.208,  0.397, -0.500, -0.208,  0.497, 
        -0.500,  0.206,  0.397, -0.500,  0.206,  0.497, 
        -0.207,  0.499,  0.397, -0.207,  0.499,  0.497, 
        ] 
    @cylinderQuadStrip9 = [
        -0.208,  0.498,  0.050, -0.208,  0.498,  0.133, 0.206,  0.499,  0.050, 0.206,  0.499,  0.133, 
        0.499,  0.207,  0.050, 0.499,  0.207,  0.133, 
        0.500, -0.207,  0.050, 0.500, -0.207,  0.133, 
        0.208, -0.500,  0.050, 0.208, -0.500,  0.133, 
        -0.206, -0.501,  0.050, -0.206, -0.501,  0.133, 
        -0.499, -0.209,  0.050, -0.499, -0.209,  0.133, 
        -0.500,  0.205,  0.050, -0.500,  0.205,  0.133, 
        -0.208,  0.498,  0.050, -0.208,  0.498,  0.133, 
        ] 
    @cylinderQuadStrip10 = [
        0.148,  0.360, -0.116, 0.206,  0.499,  0.050, 0.360,  0.149, -0.116, 0.499,  0.207,  0.050, 
        0.360, -0.149, -0.116, 0.500, -0.207,  0.050, 
        0.150, -0.361, -0.116, 0.208, -0.500,  0.050, 
        -0.148, -0.361, -0.116, -0.206, -0.501,  0.050, 
        -0.360, -0.151, -0.116, -0.499, -0.209,  0.050, 
        -0.360,  0.147, -0.116, -0.500,  0.205,  0.050, 
        -0.150,  0.359, -0.116, -0.208,  0.498,  0.050, 
        0.148,  0.360, -0.116, 0.206,  0.499,  0.050, 
        ] 
    @cylinderQuadStrip11 = [
        0.206,  0.499, -0.327, 0.148,  0.360, -0.327, 0.499,  0.207, -0.327, 0.360,  0.149, -0.327, 
        0.500, -0.207, -0.327, 0.361, -0.149, -0.327, 
        0.208, -0.500, -0.327, 0.150, -0.361, -0.327, 
        -0.206, -0.501, -0.327, -0.148, -0.362, -0.327, 
        -0.499, -0.209, -0.327, -0.360, -0.151, -0.327, 
        -0.500,  0.205, -0.327, -0.361,  0.148, -0.327, 
        -0.208,  0.498, -0.327, -0.150,  0.359, -0.327, 
        0.206,  0.499, -0.327, 0.148,  0.360, -0.327, 
        ] 
    @cylinderQuadStrip12 = [
        0.148,  0.360, -0.327, 0.148,  0.360, -0.116, 0.360,  0.149, -0.327, 0.360,  0.149, -0.116, 
        0.361, -0.149, -0.327, 0.360, -0.149, -0.116, 
        0.150, -0.361, -0.327, 0.150, -0.361, -0.116, 
        -0.148, -0.362, -0.327, -0.148, -0.361, -0.116, 
        -0.360, -0.151, -0.327, -0.360, -0.151, -0.116, 
        -0.361,  0.148, -0.327, -0.360,  0.147, -0.116, 
        -0.150,  0.359, -0.327, -0.150,  0.359, -0.116, 
        0.148,  0.360, -0.327, 0.148,  0.360, -0.116, 
        ] 
    @cylinderQuadStrip13 = [
        0.206,  0.499, -0.494, 0.206,  0.499, -0.327, 0.499,  0.207, -0.494, 0.499,  0.207, -0.327, 
        0.500, -0.207, -0.494, 0.500, -0.207, -0.327, 
        0.208, -0.500, -0.494, 0.208, -0.500, -0.327, 
        -0.206, -0.501, -0.494, -0.206, -0.501, -0.327, 
        -0.499, -0.209, -0.494, -0.499, -0.209, -0.327, 
        -0.500,  0.205, -0.494, -0.500,  0.205, -0.327, 
        -0.208,  0.498, -0.494, -0.208,  0.498, -0.327, 
        0.206,  0.499, -0.494, 0.206,  0.499, -0.327, 
        ] 
    @cylinderQuadStrip14 = [
        -0.119,  0.284, -0.494, -0.208,  0.498, -0.494, 0.118,  0.285, -0.494, 0.206,  0.499, -0.494, 
        0.285,  0.118, -0.494, 0.499,  0.207, -0.494, 
        0.286, -0.118, -0.494, 0.500, -0.207, -0.494, 
        0.119, -0.286, -0.494, 0.208, -0.500, -0.494, 
        -0.118, -0.287, -0.494, -0.206, -0.501, -0.494, 
        -0.285, -0.120, -0.494, -0.499, -0.209, -0.494, 
        -0.286,  0.117, -0.494, -0.500,  0.205, -0.494, 
        -0.119,  0.284, -0.494, -0.208,  0.498, -0.494, 
        ] 
    @cylinderQuadStrip15 = [
        0.118,  0.285,  0.133, 0.118,  0.285, -0.494, 0.285,  0.118,  0.133, 0.285,  0.118, -0.494, 
        0.286, -0.119,  0.133, 0.286, -0.118, -0.494, 
        0.119, -0.286,  0.133, 0.119, -0.286, -0.494, 
        -0.118, -0.287,  0.133, -0.118, -0.287, -0.494, 
        -0.285, -0.120,  0.133, -0.285, -0.120, -0.494, 
        -0.286,  0.117,  0.133, -0.286,  0.117, -0.494, 
        -0.119,  0.284,  0.133, -0.119,  0.284, -0.494, 
        0.118,  0.285,  0.133, 0.118,  0.285, -0.494, 
        ] 
    @cylinderQuadStrip16 = [
        0.206,  0.499,  0.133, 0.118,  0.285,  0.133, 0.499,  0.207,  0.133, 0.285,  0.118,  0.133, 
        0.500, -0.207,  0.133, 0.286, -0.119,  0.133, 
        0.208, -0.500,  0.133, 0.119, -0.286,  0.133, 
        -0.206, -0.501,  0.133, -0.118, -0.287,  0.133, 
        -0.499, -0.209,  0.133, -0.285, -0.120,  0.133, 
        -0.500,  0.205,  0.133, -0.286,  0.117,  0.133, 
        -0.208,  0.498,  0.133, -0.119,  0.284,  0.133, 
        0.206,  0.499,  0.133, 0.118,  0.285,  0.133, 
        ]
            
    #   00     00   0000000   000000000   0000000   00000000     
    #   000   000  000   000     000     000   000  000   000    
    #   000000000  000   000     000     000   000  0000000      
    #   000 0 000  000   000     000     000   000  000   000    
    #   000   000   0000000      000      0000000   000   000    
    
    @motorTriangles = [
        0.167, -0.5,  0.29, 0.5, -0.5,  0.027, 0.5, -0.167,  0.29,
        -0.5, -0.5,  0.027, -0.167, -0.5,  0.29, -0.5, -0.167,  0.29,
        -0.167,  0.5,  0.29, -0.5,  0.5,  0.027, -0.5,  0.167,  0.29,
        0.5,  0.167,  0.29, 0.5,  0.5,  0.027, 0.167,  0.5,  0.290
        ]
        
    @motorQuads = [
        -0.5, -0.5, -0.5, 0.5, -0.5, -0.5, 0.5, -0.5,  0.027, -0.5, -0.5,  0.027,
        -0.5,  0.5, -0.5, -0.5, -0.5, -0.5, -0.5, -0.5,  0.027, -0.5,  0.5,  0.027,
        0.5,  0.5, -0.5, -0.5,  0.5, -0.5, -0.5,  0.5,  0.027, 0.5,  0.5,  0.027,
        0.5, -0.5, -0.5, 0.5,  0.5, -0.5, 0.5,  0.5,  0.027, 0.5, -0.5,  0.027,
        -0.5, -0.167,  0.29, -0.5,  0.167,  0.29, -0.5,  0.5,  0.027, -0.5, -0.5,  0.027,
        -0.5, -0.167,  0.29, 0.5, -0.167,  0.29, 0.5,  0.167,  0.29, -0.5,  0.167,  0.29,
        -0.167, -0.5,  0.29, 0.167, -0.5,  0.29, 0.5, -0.167,  0.29, -0.5, -0.167,  0.29,
        0.167, -0.5,  0.29, -0.167, -0.5,  0.29, -0.5, -0.5,  0.027, 0.5, -0.5,  0.027,
        -0.167,  0.5,  0.29, 0.167,  0.5,  0.29, 0.5,  0.5,  0.027, -0.5,  0.5,  0.027,
        0.167,  0.5,  0.29, -0.167,  0.5,  0.29, -0.5,  0.167,  0.29, 0.5,  0.167,  0.29,
        0.5, -0.167,  0.29, 0.5, -0.5,  0.027, 0.5,  0.5,  0.027, 0.5,  0.167,  0.290
        ]
            
    #    0000000   00000000  000   000  00000000  00000000    0000000   000000000   0000000   00000000 
    #   000        000       0000  000  000       000   000  000   000     000     000   000  000   000
    #   000  0000  0000000   000 0 000  0000000   0000000    000000000     000     000   000  0000000  
    #   000   000  000       000  0000  000       000   000  000   000     000     000   000  000   000
    #    0000000   00000000  000   000  00000000  000   000  000   000     000      0000000   000   000

    @generatorQuads = [
        0.39, 0.330, 0.155, 0.5, 0.05, 0.155, 0.5, 0.05, -0.155, 0.39, 0.330, -0.155,
        -0.39, -0.33, 0.155, -0.5, -0.038, 0.155, -0.5, -0.038, -0.155, -0.39, -0.33, -0.155,
        0.5, -0.038, 0.155, 0.39, -0.33, 0.155, 0.39, -0.33, -0.155, 0.5, -0.038, -0.155,
        -0.33, 0.39, 0.155, -0.05, 0.5, 0.155, -0.05, 0.5, -0.155, -0.33, 0.39, -0.155,
        0.33, -0.380, 0.155, 0.05, -0.5, 0.155, 0.05, -0.5, -0.155, 0.33, -0.380, -0.155,
        0.05, 0.5, 0.155, 0.33, 0.39, 0.155, 0.33, 0.39, -0.155, 0.05, 0.5, -0.155,
        -0.5, 0.05, 0.155, -0.39, 0.330, 0.155, -0.39, 0.330, -0.155, -0.5, 0.05, -0.155,
        -0.05, -0.5, 0.155, -0.33, -0.380, 0.155, -0.33, -0.380, -0.155, -0.05, -0.5, -0.155,
        0.33,   0.05,  0.077, 0.27,   0.2,  0.077, 0.27,   0.2,  -0.077, 0.33,   0.05,  -0.077,
        -0.33, -0.05, 0.077, -0.27, -0.2, 0.077, -0.27, -0.2, -0.077, -0.33, -0.05, -0.077, 
        0.27,  -0.2, 0.077, 0.33,  -0.05, 0.077, 0.33,  -0.05, -0.077, 0.27,  -0.2, -0.077,  
        -0.05,  0.33,  0.077, -0.2,  0.27,  0.077, -0.2,  0.27,  -0.077, -0.05,  0.33,  -0.077,
        0.05,  -0.33, 0.077, 0.2,  -0.27, 0.077, 0.2,  -0.27, -0.077, 0.05,  -0.33, -0.077, 
        0.2,   0.27,  0.077, 0.05,   0.33,  0.077, 0.05,   0.33,  -0.077, 0.2,   0.27,  -0.077, 
        -0.27,  0.2,  0.077, -0.33,  0.05,  0.077, -0.33,  0.05,  -0.077, -0.27,  0.2,  -0.077, 
        -0.2, -0.27, 0.077, -0.05, -0.33, 0.077, -0.05, -0.33, -0.077, -0.2, -0.27, -0.077,  
        0.1, 0, 0.5, 0.071, 0.071, 0.5, 0, 0.1, 0.5, 0.071, -0.071, 0.5,
        -0.1, 0, 0.5, -0.071, -0.071, 0.5, 0, -0.1, 0.5, -0.071, 0.071, 0.5,
        0.071, -0.071, 0.5, 0, 0.1, 0.5, -0.071, 0.071, 0.5, 0, -0.1, 0.5,
        0.2, 0, -0.077, 0.141, -0.141, -0.077, 0, -0.2, -0.077, 0.141, 0.141, -0.077,
        -0.2, 0, -0.077, -0.141, 0.141, -0.077, 0, 0.2, -0.077, -0.141, -0.141, -0.077,
        0.141, 0.141, -0.077, 0, -0.2, -0.077, -0.141, -0.141, -0.077, 0, 0.2, -0.077,
        ]

    @generatorQuadStrip1 = [
        0.141,  0.141, -0.077, 0.141,  0.141,  0.077, 0.200,  0, -0.077, 0.200,  0,  0.077, 
        0.141, -0.141, -0.077, 0.141, -0.141,  0.077, 
        0, -0.200, -0.077, 0, -0.200,  0.077, 
        -0.141, -0.141, -0.077, -0.141, -0.141,  0.077, 
        -0.200,  0, -0.077, -0.200,  0,  0.077, 
        -0.141,  0.141, -0.077, -0.141,  0.141,  0.077, 
        0,  0.200, -0.077, 0,  0.200,  0.077, 
        0.141,  0.141, -0.077, 0.141,  0.141,  0.077, 
    ]
    @generatorQuadStrip2 = [
        0,  0.200,  0.077, 0,  0.059,  0.220, 0.141,  0.141,  0.077, 0.042,  0.042,  0.220, 
        0.200,  0,  0.077, 0.059, 0,  0.220, 
        0.141, -0.141,  0.077, 0.042, -0.042,  0.220, 
        0, -0.200,  0.077, 0, -0.059,  0.220, 
        -0.141, -0.141,  0.077, -0.042, -0.042,  0.220, 
        -0.200,  0,  0.077, -0.059, 0,  0.220, 
        -0.141,  0.141,  0.077, -0.042,  0.042,  0.220, 
        0,  0.200,  0.077, 0,  0.059,  0.220, 
    ]
    @generatorQuadStrip3 = [
        0,  0.1,  0.354, 0,  0.1,  0.5, 0.071,  0.071,  0.354, 0.071,  0.071,  0.5, 
        0.1, 0,  0.354, 0.1, 0,  0.5, 
        0.071, -0.071,  0.354, 0.071, -0.071,  0.5, 
        0, -0.1,  0.354, 0, -0.1,  0.5, 
        -0.071, -0.071,  0.354, -0.071, -0.071,  0.5, 
        -0.1, 0,  0.354, -0.1, 0,  0.5, 
        -0.071,  0.071,  0.354, -0.071,  0.071,  0.5, 
        0,  0.1,  0.354, 0,  0.1,  0.5, 
    ]
    @generatorQuadStrip4 = [
        0.042,  0.042,  0.220, 0.071,  0.071,  0.354, 0.059, 0,  0.220, 0.1, 0,  0.354, 
        0.042, -0.042,  0.220, 0.071, -0.071,  0.354, 
        0, -0.059,  0.220, 0, -0.1,  0.354, 
        -0.042, -0.042,  0.220, -0.071, -0.071,  0.354, 
        -0.059, 0,  0.220, -0.1, 0,  0.354, 
        -0.042,  0.042,  0.220, -0.071,  0.071,  0.354, 
        0,  0.059,  0.220, 0,  0.1,  0.354, 
        0.042,  0.042,  0.220, 0.071,  0.071,  0.354, 
    ]
    @generatorQuadStrip5 = [
        -0.05, -0.5,  0.155, -0.05, -0.33,  0.077, -0.33, -0.380,  0.155, -0.2, -0.27,  0.077, 
        -0.33, -0.380, -0.155, -0.2, -0.27, -0.077, 
        -0.05, -0.5, -0.155, -0.05, -0.33, -0.077, 
        -0.05, -0.5,  0.155, -0.05, -0.33,  0.077, 
    ]
    @generatorQuadStrip6 = [
        -0.5,  0.05,  0.155, -0.33,  0.05,  0.077, -0.39,  0.330,  0.155, -0.27,  0.2,  0.077, 
        -0.39,  0.330, -0.155, -0.27,  0.2, -0.077, 
        -0.5,  0.05, -0.155, -0.33,  0.05, -0.077, 
        -0.5,  0.05,  0.155, -0.33,  0.05,  0.077, 
    ]
    #         
    @generatorQuadStrip7 = [
        0.05,  0.5,  0.155, 0.05,  0.33,  0.077, 0.33,  0.39,  0.155, 0.2,  0.27,  0.077, 
        0.33,  0.39, -0.155, 0.2,  0.27, -0.077, 
        0.05,  0.5, -0.155, 0.05,  0.33, -0.077, 
        0.05,  0.5,  0.155, 0.05,  0.33,  0.077, 
    ]
    @generatorQuadStrip8 = [
        0.33, -0.380,  0.155, 0.2, -0.27,  0.077, 0.05, -0.5,  0.155, 0.05, -0.33,  0.077, 
        0.05, -0.5, -0.155, 0.05, -0.33, -0.077, 
        0.33, -0.380, -0.155, 0.2, -0.27, -0.077, 
        0.33, -0.380,  0.155, 0.2, -0.27,  0.077, 
    ]
    @generatorQuadStrip9 = [
        -0.33,  0.39,  0.155, -0.2,  0.27,  0.077, -0.05,  0.5,  0.155, -0.05,  0.33,  0.077, 
        -0.05,  0.5, -0.155, -0.05,  0.33, -0.077, 
        -0.33,  0.39, -0.155, -0.2,  0.27, -0.077, 
        -0.33,  0.39,  0.155, -0.2,  0.27,  0.077, 
    ]
    @generatorQuadStrip10 = [
        0.5, -0.038,  0.155, 0.33, -0.05,  0.077, 0.39, -0.33,  0.155, 0.27, -0.2,  0.077, 
        0.39, -0.33, -0.155, 0.27, -0.2, -0.077, 
        0.5, -0.038, -0.155, 0.33, -0.05, -0.077, 
        0.5, -0.038,  0.155, 0.33, -0.05,  0.077, 
    ]
    @generatorQuadStrip11 = [
        -0.39, -0.33,  0.155, -0.27, -0.2,  0.077, -0.5, -0.038,  0.155, -0.33, -0.05,  0.077, 
        -0.5, -0.038, -0.155, -0.33, -0.05, -0.077, 
        -0.39, -0.33, -0.155, -0.27, -0.2, -0.077, 
        -0.39, -0.33,  0.155, -0.27, -0.2,  0.077, 
    ]
    @generatorQuadStrip12 = [
        0.39,  0.330,  0.155, 0.27,  0.2,  0.077, 0.5,  0.05,  0.155, 0.33,  0.05,  0.077, 
        0.5,  0.05, -0.155, 0.33,  0.05, -0.077, 
        0.39,  0.330, -0.155, 0.27,  0.2, -0.077, 
        0.39,  0.330,  0.155, 0.27,  0.2,  0.077, 
    ]
    
    #   000   000   0000000   000      000   000  00000000
    #   000   000  000   000  000      000   000  000     
    #    000 000   000000000  000       000 000   0000000 
    #      000     000   000  000         000     000     
    #       0      000   000  0000000      0      00000000
    
    @valveQuads = [
        0.1, 0, 0.5, 0.071, 0.071, 0.5, 0, 0.1, 0.5, 0.071, -0.071, 0.5,
        -0.1, 0, 0.5, -0.071, -0.071, 0.5, 0, -0.1, 0.5, -0.071, 0.071, 0.5,
        0.071, -0.071, 0.5, 0, 0.1, 0.5, -0.071, 0.071, 0.5, 0, -0.1, 0.5,
        0.1, 0, -0.5, 0.071, -0.071, -0.5, 0, -0.1, -0.5, 0.071, 0.071, -0.5,
        -0.1, 0, -0.5, -0.071, 0.071, -0.5, 0, 0.1, -0.5, -0.071, -0.071, -0.5,
        0.071, 0.071, -0.5, 0, -0.1, -0.5, -0.071, -0.071, -0.5, 0, 0.1, -0.5,
    ]
    @valveQuadStrip1 = [
        0.071, 0.071, -0.346, 0.042, 0.042, -0.220, 0.1, 0, -0.346, 0.059, 0, -0.220, 
        0.071, -0.071, -0.346, 0.042, -0.042, -0.220, 
        0, -0.1, -0.346, 0, -0.059, -0.220, 
        -0.071, -0.071, -0.346, -0.042, -0.042, -0.220, 
        -0.1, 0, -0.346, -0.059, 0, -0.220, 
        -0.071, 0.071, -0.346, -0.042, 0.042, -0.220, 
        0, 0.1, -0.346, 0, 0.059, -0.220, 
        0.071, 0.071, -0.346, 0.042, 0.042, -0.220 
        ]
    @valveQuadStrip2 = [
        0.042, 0.042, -0.220, 0.042, 0.042, 0.220, 0.059, 0, -0.220, 0.059, 0, 0.220, 
        0.042, -0.042, -0.220, 0.042, -0.042, 0.220, 
        0, -0.059, -0.220, 0, -0.059, 0.220, 
        -0.042, -0.042, -0.220, -0.042, -0.042, 0.220, 
        -0.059, 0, -0.220, -0.059, 0, 0.220, 
        -0.042, 0.042, -0.220, -0.042, 0.042, 0.220, 
        0, 0.059, -0.220, 0, 0.059, 0.220, 
        0.042, 0.042, -0.220, 0.042, 0.042, 0.220
        ]
    @valveQuadStrip3 = [
        0.071, 0.071, -0.5, 0.071, 0.071, -0.346, 0.1, 0, -0.5, 0.1, 0, -0.346, 
        0.071, -0.071, -0.5, 0.071, -0.071, -0.346, 
        0, -0.1, -0.5, 0, -0.1, -0.346, 
        -0.071, -0.071, -0.5, -0.071, -0.071, -0.346, 
        -0.1, 0, -0.5, -0.1, 0, -0.346, 
        -0.071, 0.071, -0.5, -0.071, 0.071, -0.346, 
        0, 0.1, -0.5, 0, 0.1, -0.346, 
        0.071, 0.071, -0.5, 0.071, 0.071, -0.346,
        ] 
    @valveQuadStrip4 = [
        0, 0.1, 0.354, 0, 0.1, 0.5, 0.071, 0.071, 0.354, 0.071, 0.071, 0.5, 
        0.1, 0, 0.354, 0.1, 0, 0.5, 
        0.071, -0.071, 0.354, 0.071, -0.071, 0.5, 
        0, -0.1, 0.354, 0, -0.1, 0.5, 
        -0.071, -0.071, 0.354, -0.071, -0.071, 0.5, 
        -0.1, 0, 0.354, -0.1, 0, 0.5, 
        -0.071, 0.071, 0.354, -0.071, 0.071, 0.5, 
        0, 0.1, 0.354, 0, 0.1, 0.5,
        ]
    @valveQuadStrip5 = [
        0.042, 0.042, 0.220, 0.071, 0.071, 0.354, 0.059, 0, 0.220, 0.1, 0, 0.354, 
        0.042, -0.042, 0.220, 0.071, -0.071, 0.354, 
        0, -0.059, 0.220, 0, -0.1, 0.354, 
        -0.042, -0.042, 0.220, -0.071, -0.071, 0.354, 
        -0.059, 0, 0.220, -0.1, 0, 0.354, 
        -0.042, 0.042, 0.220, -0.071, 0.071, 0.354, 
        0, 0.059, 0.220, 0, 0.1, 0.354, 
        0.042, 0.042, 0.220, 0.071, 0.071, 0.354, 
        ]
    
    #    0000000   00000000   0000000   00000000 
    #   000        000       000   000  000   000
    #   000  0000  0000000   000000000  0000000  
    #   000   000  000       000   000  000   000
    #    0000000   00000000  000   000  000   000
                
    @gearQuadStrip1 = [ 
        0.208, -0.086, 0.111, 0.375, -0.155, 0.087, 0.226, 0, 0.111, 0.406, 0, 0.087, 
        0.208, 0.086, 0.111, 0.375, 0.155, 0.087, 
        0.160, 0.160, 0.111, 0.287, 0.287, 0.087, 
        0.086, 0.208, 0.111, 0.155, 0.375, 0.087, 
        0, 0.226, 0.111, 0, 0.406, 0.087, 
        -0.086, 0.208, 0.111, -0.155, 0.375, 0.087, 
        -0.160, 0.160, 0.111, -0.287, 0.287, 0.087, 
        -0.208, 0.086, 0.111, -0.375, 0.155, 0.087, 
        -0.226, 0, 0.111, -0.406, 0, 0.087, 
        -0.208, -0.086, 0.111, -0.375, -0.155, 0.087, 
        -0.160, -0.160, 0.111, -0.287, -0.287, 0.087, 
        -0.086, -0.208, 0.111, -0.155, -0.375, 0.087, 
        0, -0.226, 0.111, 0, -0.406, 0.087, 
        0.086, -0.208, 0.111, 0.155, -0.375, 0.087, 
        0.160, -0.160, 0.111, 0.287, -0.287, 0.087, 
        0.208, -0.086, 0.111, 0.375, -0.155, 0.087, 
        ]
         
    @gearQuadStrip2 = [
        0.226, 0, -0.111, 0.226, 0, 0.111, 0.208, 0.086, -0.111, 0.208, 0.086, 0.111, 
        0.160, 0.160, -0.111, 0.160, 0.160, 0.111, 
        0.086, 0.208, -0.111, 0.086, 0.208, 0.111, 
        0, 0.226, -0.111, 0, 0.226, 0.111, 
        -0.086, 0.208, -0.111, -0.086, 0.208, 0.111, 
        -0.160, 0.160, -0.111, -0.160, 0.160, 0.111, 
        -0.208, 0.086, -0.111, -0.208, 0.086, 0.111, 
        -0.226, 0, -0.111, -0.226, 0, 0.111, 
        -0.208, -0.086, -0.111, -0.208, -0.086, 0.111, 
        -0.160, -0.160, -0.111, -0.160, -0.160, 0.111, 
        -0.086, -0.208, -0.111, -0.086, -0.208, 0.111, 
        0, -0.226, -0.111, 0, -0.226, 0.111, 
        0.086, -0.208, -0.111, 0.086, -0.208, 0.111, 
        0.160, -0.160, -0.111, 0.160, -0.160, 0.111, 
        0.208, -0.086, -0.111, 0.208, -0.086, 0.111, 
        0.226, 0, -0.111, 0.226, 0, 0.111, 
        ]
        
    @gearQuadStrip3 = [
        0.406, 0, -0.087, 0.226, 0, -0.111, 0.375, 0.155, -0.087, 0.208, 0.086, -0.111, 
        0.287, 0.287, -0.087, 0.160, 0.160, -0.111, 
        0.155, 0.375, -0.087, 0.086, 0.208, -0.111, 
        0, 0.406, -0.087, 0, 0.226, -0.111, 
        -0.155, 0.375, -0.087, -0.086, 0.208, -0.111, 
        -0.287, 0.287, -0.087, -0.160, 0.160, -0.111, 
        -0.375, 0.155, -0.087, -0.208, 0.086, -0.111, 
        -0.406, 0, -0.087, -0.226, 0, -0.111, 
        -0.375, -0.155, -0.087, -0.208, -0.086, -0.111, 
        -0.287, -0.287, -0.087, -0.160, -0.160, -0.111, 
        -0.155, -0.375, -0.087, -0.086, -0.208, -0.111, 
        0, -0.406, -0.087, 0, -0.226, -0.111, 
        0.155, -0.375, -0.087, 0.086, -0.208, -0.111, 
        0.287, -0.287, -0.087, 0.160, -0.160, -0.111, 
        0.375, -0.155, -0.087, 0.208, -0.086, -0.111, 
        0.406, 0, -0.087, 0.226, 0, -0.111, 
        ]
                            
    @gearQuads = [ 
        0.375, 0.155, 0.087, 0.406, 0, 0.087, 0.406, 0, -0.087, 0.375, 0.155, -0.087,
        0.155, 0.375, 0.087, 0.287, 0.287, 0.087, 0.287, 0.287, -0.087, 0.155, 0.375, -0.087,
        -0.155, 0.375, 0.087, 0, 0.406, 0.087, 0, 0.406, -0.087, -0.155, 0.375, -0.087,
        -0.375, 0.155, 0.087, -0.287, 0.287, 0.087, -0.287, 0.287, -0.087, -0.375, 0.155, -0.087,
        -0.375, -0.155, 0.087, -0.406, 0, 0.087, -0.406, 0, -0.087, -0.375, -0.155, -0.087,
        -0.155, -0.375, 0.087, -0.287, -0.287, 0.087, -0.287, -0.287, -0.087, -0.155, -0.375, -0.087,
        0.155, -0.375, 0.087, 0, -0.406, 0.087, 0, -0.406, -0.087, 0.155, -0.375, -0.087,
        0.375, -0.155, 0.087, 0.287, -0.287, 0.087, 0.287, -0.287, -0.087, 0.375, -0.155, -0.087,
        0.534, -0.159, -0.05, 0.534, -0.159, 0.05, 0.375, -0.155, 0.087, 0.375, -0.155, -0.087,
        0.554, -0.058, -0.05, 0.534, -0.159, -0.05, 0.375, -0.155, -0.087, 0.406, 0, -0.087,
        0.554, -0.058, 0.05, 0.554, -0.058, -0.05, 0.406, 0, -0.087, 0.406, 0, 0.087,
        0.554, -0.058, 0.05, 0.534, -0.159, 0.05, 0.534, -0.159, -0.05, 0.554, -0.058, -0.05,
        0.534, -0.159, 0.05, 0.554, -0.058, 0.05, 0.406, 0, 0.087, 0.375, -0.155, 0.087,
        0.266, -0.490, -0.05, 0.266, -0.490, 0.05, 0.155, -0.375, 0.087, 0.155, -0.375, -0.087,
        0.351, -0.433, -0.05, 0.266, -0.490, -0.05, 0.155, -0.375, -0.087, 0.287, -0.287, -0.087,
        0.351, -0.433, 0.05, 0.351, -0.433, -0.05, 0.287, -0.287, -0.087, 0.287, -0.287, 0.087,
        0.351, -0.433, 0.05, 0.266, -0.490, 0.05, 0.266, -0.490, -0.05, 0.351, -0.433, -0.05,
        0.266, -0.490, 0.05, 0.351, -0.433, 0.05, 0.287, -0.287, 0.087, 0.155, -0.375, 0.087,
        -0.159, -0.534, -0.05, -0.159, -0.534, 0.05, -0.155, -0.375, 0.087, -0.155, -0.375, -0.087,
        -0.058, -0.554, -0.05, -0.159, -0.534, -0.05, -0.155, -0.375, -0.087, 0, -0.406, -0.087,
        -0.058, -0.554, 0.05, -0.058, -0.554, -0.05, 0, -0.406, -0.087, 0, -0.406, 0.087,
        -0.058, -0.554, 0.05, -0.159, -0.534, 0.05, -0.159, -0.534, -0.05, -0.058, -0.554, -0.05,
        -0.159, -0.534, 0.05, -0.058, -0.554, 0.05, 0, -0.406, 0.087, -0.155, -0.375, 0.087,
        -0.490, -0.266, -0.05, -0.490, -0.266, 0.05, -0.375, -0.155, 0.087, -0.375, -0.155, -0.087,
        -0.433, -0.351, -0.05, -0.490, -0.266, -0.05, -0.375, -0.155, -0.087, -0.287, -0.287, -0.087,
        -0.433, -0.351, 0.05, -0.433, -0.351, -0.05, -0.287, -0.287, -0.087, -0.287, -0.287, 0.087,
        -0.433, -0.351, 0.05, -0.490, -0.266, 0.05, -0.490, -0.266, -0.05, -0.433, -0.351, -0.05,
        -0.490, -0.266, 0.05, -0.433, -0.351, 0.05, -0.287, -0.287, 0.087, -0.375, -0.155, 0.087,
        -0.534, 0.159, -0.05, -0.534, 0.159, 0.05, -0.375, 0.155, 0.087, -0.375, 0.155, -0.087,
        -0.554, 0.058, -0.05, -0.534, 0.159, -0.05, -0.375, 0.155, -0.087, -0.406, 0, -0.087,
        -0.554, 0.058, 0.05, -0.554, 0.058, -0.05, -0.406, 0, -0.087, -0.406, 0, 0.087,
        -0.554, 0.058, 0.05, -0.534, 0.159, 0.05, -0.534, 0.159, -0.05, -0.554, 0.058, -0.05,
        -0.534, 0.159, 0.05, -0.554, 0.058, 0.05, -0.406, 0, 0.087, -0.375, 0.155, 0.087,
        -0.266, 0.490, -0.05, -0.266, 0.490, 0.05, -0.155, 0.375, 0.087, -0.155, 0.375, -0.087,
        -0.351, 0.433, -0.05, -0.266, 0.490, -0.05, -0.155, 0.375, -0.087, -0.287, 0.287, -0.087,
        -0.351, 0.433, 0.05, -0.351, 0.433, -0.05, -0.287, 0.287, -0.087, -0.287, 0.287, 0.087,
        -0.351, 0.433, 0.05, -0.266, 0.490, 0.05, -0.266, 0.490, -0.05, -0.351, 0.433, -0.05,
        -0.266, 0.490, 0.05, -0.351, 0.433, 0.05, -0.287, 0.287, 0.087, -0.155, 0.375, 0.087,
        0.159, 0.534, -0.05, 0.159, 0.534, 0.05, 0.155, 0.375, 0.087, 0.155, 0.375, -0.087,
        0.058, 0.554, -0.05, 0.159, 0.534, -0.05, 0.155, 0.375, -0.087, 0, 0.406, -0.087,
        0.058, 0.554, 0.05, 0.058, 0.554, -0.05, 0, 0.406, -0.087, 0, 0.406, 0.087,
        0.058, 0.554, 0.05, 0.159, 0.534, 0.05, 0.159, 0.534, -0.05, 0.058, 0.554, -0.05,
        0.159, 0.534, 0.05, 0.058, 0.554, 0.05, 0, 0.406, 0.087, 0.155, 0.375, 0.087,
        0.490, 0.266, -0.05, 0.490, 0.266, 0.05, 0.375, 0.155, 0.087, 0.375, 0.155, -0.087,
        0.433, 0.351, -0.05, 0.490, 0.266, -0.05, 0.375, 0.155, -0.087, 0.287, 0.287, -0.087,
        0.433, 0.351, 0.05, 0.433, 0.351, -0.05, 0.287, 0.287, -0.087, 0.287, 0.287, 0.087,
        0.433, 0.351, 0.05, 0.490, 0.266, 0.05, 0.490, 0.266, -0.05, 0.433, 0.351, -0.05,
        0.490, 0.266, 0.05, 0.433, 0.351, 0.05, 0.287, 0.287, 0.087, 0.375, 0.155, 0.087
        ]

module.exports = Geom
